﻿namespace Hotline.Share.Dtos.Order
{

    public class DepartmentAcceptanceTypeStatisticsDto
    {
        /// <summary>
        /// 部门名称
        /// </summary>
        public string OrgName { get; set; }

        /// <summary>
        /// 部门类型
        /// </summary>
        public string OrgType { get; set; }

        /// <summary>
        /// 总量
        /// </summary>
        public int AllCount => ZxAllCount + JyAllCount + QzAllCount + ByAllCount + JbAllCount + TsAllCount + QtAllCount;
        public double? AllTimes => ZxAllTimes + JyAllTimes + QzAllTimes + ByAllTimes + JbAllTimes + TsAllTimes + QtAllTimes;
        public double? AverageTime => GetCalculateAverage(AllCount, AllTimes);

        /// <summary>
        /// 咨询
        /// </summary>
        public int ZxAllCount { get; set; }
        public double? ZxAllTimes { get; set; }
        public double? ZxAverageTime => GetCalculateAverage(ZxAllCount, ZxAllTimes);

        /// <summary>
        /// 建议
        /// </summary>
        public int JyAllCount { get; set; }
        public double? JyAllTimes { get; set; }
        public double? JyAverageTime => GetCalculateAverage(JyAllCount, JyAllTimes);

        /// <summary>
        /// 求助
        /// </summary>
        public int QzAllCount { get; set; }
        public double? QzAllTimes { get; set; }
        public double? QzAverageTime => GetCalculateAverage(QzAllCount, QzAllTimes);

        /// <summary>
        /// 表扬
        /// </summary>
        public int ByAllCount { get; set; }
        public double? ByAllTimes { get; set; }
        public double? ByAverageTime => GetCalculateAverage(ByAllCount, ByAllTimes);

        /// <summary>
        /// 举报
        /// </summary>
        public int JbAllCount { get; set; }
        public double? JbAllTimes { get; set; }
        public double? JbAverageTime => GetCalculateAverage(JbAllCount, JbAllTimes);

        /// <summary>
        /// 投诉
        /// </summary>
        public int TsAllCount { get; set; }
        public double? TsAllTimes { get; set; }
        public double? TsAverageTime => GetCalculateAverage(TsAllCount, TsAllTimes);

        /// <summary>
        /// 其他
        /// </summary>
        public int QtAllCount { get; set; }
        public double? QtAllTimes { get; set; }
        public double? QtAverageTime => GetCalculateAverage(QtAllCount, QtAllTimes);

        /// <summary>
        /// 计算平均
        /// </summary>
        /// <param name="count"></param>
        /// <param name="Times"></param>
        /// <returns></returns>
        public double GetCalculateAverage(int count, double? Times)
        {
            if (count != 0 && Times != null && Times != 0)
            {
                return Math.Round((Times.Value / (double)count) * 100, 2);
            }
            return 0;
        }
    }
}
